.nolist
include \masm32\include\masm32rt.inc

Comment @ 
[url=http://blogs.msdn.com/oldnewthing/archive/2004/09/08/226797.aspx]The Old New Thing:[/url]
Note that changing the page size creates all sorts of problems for compatibility.
There are large numbers of programs out there that blindly assume that the page
size is 4K. Boy are they in for a surprise.@

.data?
buffer	db 500 dup (?)
s4096	dd ?
s409x	dd ?
s4090	dd ?

.data
info	SYSTEM_INFO <0>
AppName	db "Testing stack corruption:", 0
sc	db "stack counter: ", 9, 0
vb	db 13, 10, "var before: ", 9, 0
va	db 13, 10, "var after: ", 9, 0
ps	db 13, 10, "page size:", 9, 0

.code

start:
	if 1
		m2m eax, 12212		; 12212 bytes OK, 12214 crash
	else
		invoke GetSystemInfo, addr info
		mov eax, info.dwPageSize
	endif
	mov s4096, eax
	sub eax, 6
	mov s4090, eax
	add eax, 20
	mov s409x, eax
;	invoke MessageBox, 0, str$(info.dwPageSize), chr$("Page size:"), MB_OK
	call StackTest
	invoke ExitProcess, 0

StackTest proc
LOCAL before:DWORD
LOCAL StartBuf:DWORD
LOCAL after:DWORD
;int 3
  magicB EQU 12345678
  magicA EQU 987654321
  mov before, magicB
  mov after, magicA
  lea edx, StartBuf		
  sub edx, s4096			; page size
  pushad
  MsgBox 0, hex$(edx), "Edx=", MB_OK
  popad
  xor ecx, ecx
  mov eax, ecx
  .While ecx<s409x		; 4096+x - will crash at some point
	.if ecx>s4090 || before!=magicB || after!=magicA
		pushad			; displaying will change the acd registers
		push ecx		; for showing str$(ecx)
		invoke lstrcpy, addr buffer, addr sc
		pop ecx
		invoke lstrcat, addr buffer, str$(ecx)
		invoke lstrcat, addr buffer, addr ps
		invoke lstrcat, addr buffer, str$(info.dwPageSize)
		invoke lstrcat, addr buffer, addr vb
		invoke lstrcat, addr buffer, str$(before)
		invoke lstrcat, addr buffer, addr va
		invoke lstrcat, addr buffer, str$(after)
		lea eax, buffer
		if 0
			; int 3
		else
		fn MessageBox, 0, addr buffer, addr AppName, MB_OKCANCEL
		.if eax==IDCANCEL
			popad
			.break
		.endif
		endif
		popad
	.endif
	mov [edx], al
	inc edx
	inc ecx
  .Endw
;  fn MessageBox, 0, str$(ecx), "Exit at ecx=", MB_OK
  ret
StackTest endp
end start

OPT_Tmp2Asm	1
